SHEBANG
# Copyright @BABOLO (C)2013 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.1 2013/03/17 21:28:11 babolo Exp $

JNTROSTUP(s_client,,dnl
,dnl
# jailup ${inclass} dir jailname jailaddr to [user [group [port]]]
#     where dir relative to ${jailupdir} and ${jailrodir}
#           jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           to - host:port to connect to
# system openssl
#                                                   useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
toto="${4}"
user="${5:-nobody}"
group="${6:-nogroup}"
port="${7:-80}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
echo "localtime" | ${up_data} "${conf_dir}/" /etc/

${up_conf} "${conf_dir}/" /etc/ <<- EOF
	host.conf hosts protocols resolv.conf
EOF

${up_genlist} libexec/ ${MTREE} | ${up_libexe} "${main_dir}/libexec/"
${up_genlist} libexec/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
${up_ponf} "${conf_dir}/xinetd" "${TEMPLATE}"
      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####

${sed} -e "s|%%TO%%|${toto}|"\
       -e "s|%%PORT%%|${port}|"\
       -e "s|%%GROUP%%|${group}|"\
       -e "s|%%USER%%|${user}|" "${TEMPLATE}" | ${up_ponf} "${conf_dir}/xinetd"

${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	nogroup:*:65533:
	nobody:*:65534:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:root:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=dir uname=root gname=wheel mode=0755 flags=none
.
/set type=file mode=0644
    host.conf
    hosts
    resolv.conf
    localtime
    protocols
    group
    xinetd
/set mode=0600
    master.passwd
    master.template
..
EOF

${up_adc} "${JAILUPRC}" <<- EOF
#${genclass}	xinetd		${jdir}	${jailsname}	${jailsaddr}	0	0	0	xinetd
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev		devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc		nullfs	ro,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
